package ccc.GMapDemo;

import gmap.GMapHandler;
import gmap.GPoint;
import android.app.Activity;
import android.content.Context;
import android.graphics.Canvas;
import android.graphics.Paint;
import android.graphics.Paint.Align;
import android.os.Bundle;
import android.os.Handler;
import android.view.KeyEvent;
import android.view.Menu;
import android.view.MenuItem;
import android.view.MotionEvent;
import android.view.View;

public class GMapDemo extends Activity {

	// e
	GmapView view;
	
	// Ign
	GPoint center = new GPoint(24.448541368875834, 118.32220673561096, 19);
	
	// RAaGoogle Map Key
	String key="ABQIAAAAsHkLYX5ar3b-5P7EhsjhXBQ5g4cqN0MUBoV1v7EHe2z9rhP7AxSpu5jlSkMDTRq_cjvF4r10wvd_lQ";
	//String key = "ABQIAAAAz2rjkrilGZTguphQT5RQqxQnA14KtgqpIfJzkpdB1-oq1QYeLRTl0Szkt5Yli5Jv9oBOrf85JNpgIw";
	//String key = "ABQIAAAAz2rjkrilGZTguphQT5RQqxQQIe5j7nozdTIq37ll2BjQmE8XsxTUxidRqBWWrDXy2cwQU686YRJCTQ";
	
	// Google Map Bz
	GMapHandler gmap;
	
	// ƥBz
	Handler handle=new Handler();
	
	// {iJI
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        
        // Google Map Bz
		gmap = new GMapHandler(center, 300, 300, key);
		gmap.setLoadingImage(this.getResources(), R.drawable.loading);
		view = new GmapView(this);
		setContentView(view);
        
        // ]wUaϮɪ^Iƥ
    	gmap.setDownloadCallBack(new GMapHandler.DownloadCallback() {		
			public void downloadCallback() {
				handle.post(new Runnable() {					
					public void run() {
						GMapDemo.this.view.invalidate();		
					}
				});
				
				//Log.i("GMAP", "AsuncDownloadCallback");
			}
		});
    }
    
    // jYp
    protected static final int MENU_ZoomIn = Menu.FIRST;
    protected static final int MENU_ZoomOut = Menu.FIRST+1;
	

    // l
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		menu.add(0, MENU_ZoomIn, 0, "j");
		menu.add(0, MENU_ZoomOut, 0, "Yp");
		return super.onCreateOptionsMenu(menu);
	};

	
	// 涵ؿ
	@Override
	public boolean onOptionsItemSelected(MenuItem item) {
		int zoom=gmap.getZoom();
		switch (item.getItemId()) {
		case MENU_ZoomIn:
			if(zoom<19)
				gmap.setZoom(++zoom);
			break;
		case MENU_ZoomOut:			
			if(zoom>0)
				gmap.setZoom(--zoom);
			break;
		}
		view.invalidate();
		return super.onOptionsItemSelected(item);
	}

	// Ĳƥ
	@Override
	public boolean onTouchEvent(MotionEvent event) {

		int pointCount = event.getHistorySize();

		if (pointCount > 0) {
			float dx = event.getHistoricalX(pointCount - 1)
					- event.getHistoricalX(0);
			float dy = event.getHistoricalY(pointCount - 1)
					- event.getHistoricalY(0);
			gmap.offset((int) -dx, (int) -dy);
			view.invalidate();
		}

		return super.onTouchEvent(event);
	}
	
	 // Lƥ
	@Override 
	public boolean onKeyDown(int keyCode, KeyEvent event) {
		  if(keyCode==KeyEvent.KEYCODE_DPAD_LEFT){
			  gmap.offset(-10, 0);  
		  }
		  if(keyCode==KeyEvent.KEYCODE_DPAD_RIGHT){
			  gmap.offset(10, 0);  
		  }
		  if(keyCode==KeyEvent.KEYCODE_DPAD_UP){
			  gmap.offset(0, -10);			  
		  }
		  if(keyCode==KeyEvent.KEYCODE_DPAD_DOWN){
			  gmap.offset(0, 10);  
		  }
		  
		  
		  view.invalidate();
		return super.onKeyDown(keyCode, event);
	}
  
	// e
    class GmapView extends View{

		public GmapView(Context context) {
			super(context);

		}
		@Override 
		protected void onDraw(Canvas canvas) {
			Paint p=new Paint();
			p.setARGB(255, 255, 255, 255);
			p.setTextSize(12);
			p.setTextAlign(Align.LEFT);
			
			// եΪURAa 
			//Bitmap tmp= GMapDownloader.getGMap(center, 256, 256, key);
			//canvas.drawBitmap(tmp, 0, 0,p);
			
			// øXa
			gmap.draw(canvas);
			super.onDraw(canvas);
		}
		
	
    }
}