package gmap;

import java.net.URL;
import java.net.URLConnection;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.net.Proxy;


public class GMapDownloader {

	public static Bitmap getNoLogoGMap(GPoint center, int width, int height,
			String key) {
		GPoint fixedPoint = new GPoint(center.X, center.Y + 15, center.Zoom);
		height += 30;
		Bitmap srcImg = getGMap(fixedPoint, width, height, key);
		
		if (srcImg != null) {
			Bitmap fixedBitmap = Bitmap.createBitmap(srcImg, 0, 0, width,
					height - 30);
			srcImg.recycle();
			return fixedBitmap;
		} else {
			return null;
		}

	}

	public static Bitmap getGMap(GPoint center, int width, int height,
			String key) {

		GLatLng latlng = center.getGLatLng();
		double lat = latlng.lat;
		double lng = latlng.lng;
		int zoom = center.Zoom;
		Bitmap downloadBitmap = downloadImg(lat, lng, zoom, width, height, key);
		return downloadBitmap;

	}

	private static Bitmap downloadImg(double lat, double lng, int zoom,
			int width, int height, String key) {
		try {
			String size = String.format("%1sx%2s", width, height);
			// }
			String urlString = String
					.format(
							"http://maps.google.com/staticmap?center=%1$s,%2$s&zoom=%3$s&size=%4$s&maptype=hybrid&sensor=false&key=%5$s",
							lat, lng, zoom, size, key);
			URL url ;// use proxy server
			if(Proxy.getDefaultHost()==null)
				url = new URL(urlString);
			else
				url = new URL("http",Proxy.getDefaultHost(),Proxy.getDefaultPort(), urlString);

			// su
			URLConnection conn = url.openConnection();
			conn.connect();
			return BitmapFactory.decodeStream(conn.getInputStream());
		} catch (Exception ex) {
			return null;
		}
	}

}
