package gmap;

public class GPoint {
		int X;
		int Y;
		int Zoom;
		
		
		public GPoint(double lat,double lng,int zoom){
			this.X=MercatorProjection.LngToX(lng, zoom);
			this.Y=MercatorProjection.LatToY(lat, zoom);
			this.Zoom=zoom;
		}

		public GPoint(int x,int y,int zoom){
			this.X = x;
			this.Y = y;
			this.Zoom = zoom;
		}
		
		public GPoint(GLatLng latlng, int zoom) {
			this.X=MercatorProjection.LngToX(latlng.lng, zoom);
			this.Y=MercatorProjection.LatToY(latlng.lat, zoom);
			this.Zoom=zoom;
		}
		
		
		public GPoint(GPoint point){
			this.X = point.X;
			this.Y = point.Y;
			this.Zoom = point.Zoom;
		}
		
		// 첾
		public void offset(int dx,int dy){
			this.X += dx;
			this.Y += dy;
		}
		
		// ogn
		public GLatLng getGLatLng(){
			return new GLatLng(X, Y, Zoom);
		}

		// r
		public String toString(){
			return String.format("GX=%1$s GY=%2$s GZ=%3$s", X, Y, Zoom);
		}
		
		// ]wY
		public void setZoom(int zoom) {
			GLatLng latlng = new GLatLng(this);
			this.X = MercatorProjection.LngToX(latlng.lng, zoom);
			this.Y = MercatorProjection.LatToY(latlng.lat, zoom);
			this.Zoom = zoom;
		}
}
