package gmap;

public class MercatorProjection {
	   // gনI(point)
    public static int LngToX(double Longitude,int zoom)
    {
        int numberOfTiles = 1 << zoom << 8;
        return (int)((Longitude + 180.0) * numberOfTiles / 360.0);
    }

    // nনI(point)
    public static int LatToY(double Latitude,int zoom)
    {
        int numberOfTiles = 1 << zoom << 8;
        double projection = Math.log(Math.tan(Math.PI / 4 + ((Latitude / 180 * Math.PI) / 2)));
        double y = (projection / Math.PI);
        y = 1.0 - y;
        y = y / 2.0 * numberOfTiles;

        return (int)y;
    }

    // I(X)নg
    public static double XToLng(int pointX,int zoom)
    {
        int numberOfTiles = 1 << zoom << 8;
        return (pointX * (360.0 / numberOfTiles)) - 180.0;
    }


    // I(Y)নn
    public static double YToLat(int pointY,int zoom)
    {
        int numberOfTiles = 1 << zoom << 8;
        double Latitude = pointY * (2.0 / numberOfTiles);
        Latitude = 1 - Latitude;
        Latitude = Latitude * Math.PI;
        Latitude = Math.atan(Math.sinh(Latitude)) * 180.0 / Math.PI;
        return Latitude;
    }
}
